# -*- coding: utf-8 -*-

#1a) Si scriva una funzione dict_from_f(fun, seq) che, data una funzione fun e 
# una sequenza seq, restituisca un dizionario le cui chiavi siano valori in 
# output della funzione, e i cui valori siano liste con gli elementi di seq 
# che, se dati in input a fun, danno la chiave.
# Osservazione: questa funzione ha lo scopo di partizionare gli elementi in 
# sottogruppi, ognuno dei quali ha elementi con una specifica caratteristica 
# comune; tale caratteristica comune viene determinata dall'applicazione di f.
#
# Es: l0 = ["C","i","a","O"]
#     dict_from_f( str.isupper , l0 )  #ovvero: raggruppo per car. maiuscoli
#     #-> {False: ['i', 'a'], True: ['C', 'O']}
#
#     dict_from_f( lambda x:x%2 , xrange(7) ) #ovvero: raggr. per pari/dispari
#     #-> {0: [0, 2, 4, 6], 1: [1, 3, 5]}
#
#     l1 = [[0,1],[], (4,), "ciao", "no", range(4)]
#     dict_from_f( len , l1)  #ovvero: raggruppo gli elem. di stessa lunghezza
#     #-> {0: [[]], 1: [(4,)], 2: [[0, 1], 'no'], 4: ['ciao', [0, 1, 2, 3]]}


def dict_from_f(fun, seq):
    mydict = {}
    for val in seq:
        k = fun(val)
        if k not in mydict:
            mydict[k] = [val]
        else:
            mydict[k].append(val)
    return mydict
