# -*- coding: utf-8 -*-

#4a) La consensus sequence per un insieme di sequenze di DNA tutte della stessa 
# lunghezza, così come definita al punto 3), può essere espressa in modo 
# compatto utilizzando un appropriato alfabeto standard di IUPAC, detto 
# "ambiguous DNA coding": in esso si usano simboli speciali ("ambiguity 
# characters") per identificare la presenza di 2, 3 o 4 diverse possibili basi 
# in una certa posizione. Le convenzioni sono le seguenti:
# una qualsiasi base -> N ; 
# C o T -> Y (pYrimidines); A o G -> R (puRines); 
# A o T -> W (Weak);        C o G -> S (Strong); 
# A o C -> M (aMino);       G o T -> K (Keto);
# not A -> B;   not C -> D;   not G -> H;   not T -> V.
#
# Si scriva la funzione iupac_dnaconsensus(ls) che restituisce la stringa 
# corrispondente alla consensus sequence delle stringhe di DNA nella lista ls,
# adottando la codifica IUPAC descritta.


from soluzione3 import strs_summarize

notation_map = {"[ACGT]":"N",           \
                "[CT]":"Y", "[AG]":"R", \
                "[AT]":"W", "[CG]":"S", \
                "[AC]":"M", "[GT]":"K", \
                "[CGT]":"B", "[AGT]":"D", "[ACT]":"H", "[ACG]":"V"}

def iupac_dnaconsensus(ls):
    consensus = strs_summarize(ls)
    for pattern, iupacsymbol in notation_map.iteritems():
        consensus = consensus.replace(pattern, iupacsymbol)
    return consensus
